import * as i0 from '@angular/core';
import { Component, Input } from '@angular/core';
import { BehaviorSubject, map } from 'rxjs';
import { Color } from '@mintplayer/ng-bootstrap';
import { AsyncPipe } from '@angular/common';

class BsBadgeComponent {
    constructor() {
        this.colors = Color;
        //#region Type
        this.type$ = new BehaviorSubject(Color.primary);
        this.colorClass$ = this.type$
            .pipe(map((type) => `bg-${this.colors[type]}`));
    }
    get type() {
        return this.type$.value;
    }
    set type(value) {
        this.type$.next(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsBadgeComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.1", type: BsBadgeComponent, isStandalone: true, selector: "bs-badge", inputs: { type: "type" }, ngImport: i0, template: "<span class=\"badge\" [class]=\"colorClass$ | async\">\n    <ng-content></ng-content>\n</span>", styles: [":host ::ng-deep .badge{--bs-badge-padding-x: .65em;--bs-badge-padding-y: .35em;--bs-badge-font-size: .75em;--bs-badge-font-weight: 700;--bs-badge-color: #fff;--bs-badge-border-radius: var(--bs-border-radius);display:inline-block;padding:var(--bs-badge-padding-y) var(--bs-badge-padding-x);font-size:var(--bs-badge-font-size);font-weight:var(--bs-badge-font-weight);line-height:1;color:var(--bs-badge-color);text-align:center;white-space:nowrap;vertical-align:baseline;border-radius:var(--bs-badge-border-radius)}:host ::ng-deep .badge:empty{display:none}:host ::ng-deep .btn .badge{position:relative;top:-1px}\n"], dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsBadgeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-badge', standalone: true, imports: [AsyncPipe], template: "<span class=\"badge\" [class]=\"colorClass$ | async\">\n    <ng-content></ng-content>\n</span>", styles: [":host ::ng-deep .badge{--bs-badge-padding-x: .65em;--bs-badge-padding-y: .35em;--bs-badge-font-size: .75em;--bs-badge-font-weight: 700;--bs-badge-color: #fff;--bs-badge-border-radius: var(--bs-border-radius);display:inline-block;padding:var(--bs-badge-padding-y) var(--bs-badge-padding-x);font-size:var(--bs-badge-font-size);font-weight:var(--bs-badge-font-weight);line-height:1;color:var(--bs-badge-color);text-align:center;white-space:nowrap;vertical-align:baseline;border-radius:var(--bs-badge-border-radius)}:host ::ng-deep .badge:empty{display:none}:host ::ng-deep .btn .badge{position:relative;top:-1px}\n"] }]
        }], ctorParameters: () => [], propDecorators: { type: [{
                type: Input
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { BsBadgeComponent };
//# sourceMappingURL=mintplayer-ng-bootstrap-badge.mjs.map
