import { DOCUMENT } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Directive, Inject, Input, Output, HostListener } from '@angular/core';

class BsCopyDirective {
    constructor(doc) {
        this.bsCopy = null;
        this.bsCopied = new EventEmitter();
        this.doc = doc;
    }
    click(event) {
        event.preventDefault();
        const listener = (e) => {
            if (!!this.bsCopy && !!window) {
                const clipboard = e.clipboardData || window['clipboardData'] || null;
                if (clipboard) {
                    clipboard.setData('text', this.bsCopy?.toString());
                    e.preventDefault();
                    this.bsCopied.emit(this.bsCopy);
                }
            }
        };
        this.doc.addEventListener('copy', listener, false);
        this.doc.execCommand('copy');
        this.doc.removeEventListener('copy', listener, false);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsCopyDirective, deps: [{ token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.3.1", type: BsCopyDirective, isStandalone: true, selector: "[bsCopy]", inputs: { bsCopy: "bsCopy" }, outputs: { bsCopied: "bsCopied" }, host: { listeners: { "click": "click($event)" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsCopyDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsCopy]',
                    standalone: true,
                }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }], propDecorators: { bsCopy: [{
                type: Input
            }], bsCopied: [{
                type: Output
            }], click: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { BsCopyDirective };
//# sourceMappingURL=mintplayer-ng-bootstrap-copy.mjs.map
