import { DatePipe } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, Output, Input } from '@angular/core';
import { Color } from '@mintplayer/ng-bootstrap';
import { BsButtonTypeDirective } from '@mintplayer/ng-bootstrap/button-type';
import { BsCalendarComponent } from '@mintplayer/ng-bootstrap/calendar';
import * as i1 from '@mintplayer/ng-bootstrap/dropdown';
import { BsDropdownModule } from '@mintplayer/ng-bootstrap/dropdown';
import * as i2 from '@mintplayer/ng-bootstrap/has-overlay';
import { BsHasOverlayComponent } from '@mintplayer/ng-bootstrap/has-overlay';

class BsDatepickerComponent {
    constructor() {
        this.colors = Color;
        //#region SelectedDate
        this._selectedDate = new Date();
        this.selectedDateChange = new EventEmitter();
        //#endregion
        //#region CurrentMonth
        this._currentMonth = new Date();
        this.currentMonthChange = new EventEmitter();
    }
    get selectedDate() {
        return this._selectedDate;
    }
    set selectedDate(value) {
        this._selectedDate = value;
        this.selectedDateChange.emit(value);
    }
    get currentMonth() {
        return this._currentMonth;
    }
    set currentMonth(value) {
        this._currentMonth = value;
        this.currentMonthChange.emit(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsDatepickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.1", type: BsDatepickerComponent, isStandalone: true, selector: "bs-datepicker", inputs: { selectedDate: "selectedDate", currentMonth: "currentMonth", disableDateFn: "disableDateFn" }, outputs: { selectedDateChange: "selectedDateChange", currentMonthChange: "currentMonthChange" }, ngImport: i0, template: "<!-- <bs-dropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\"></bs-dropdown> -->\n<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle [color]=\"colors.primary\">{{ selectedDate | date }}</button>\n    <bs-has-overlay></bs-has-overlay>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\" [disableDateFn]=\"disableDateFn\"></bs-calendar>\n    </div>\n</div>", styles: [""], dependencies: [{ kind: "pipe", type: DatePipe, name: "date" }, { kind: "component", type: BsCalendarComponent, selector: "bs-calendar", inputs: ["currentMonth", "selectedDate", "disableDateFn"], outputs: ["currentMonthChange", "selectedDateChange"] }, { kind: "ngmodule", type: BsDropdownModule }, { kind: "directive", type: i1.BsDropdownDirective, selector: "[bsDropdown]", inputs: ["hasBackdrop", "sameWidth", "closeOnClickOutside", "sameDropdownWidth", "isOpen"], outputs: ["isOpenChange"] }, { kind: "directive", type: i1.BsDropdownToggleDirective, selector: "[bsDropdownToggle]" }, { kind: "directive", type: i1.BsDropdownMenuDirective, selector: "[bsDropdownMenu]" }, { kind: "component", type: i2.BsHasOverlayComponent, selector: "bs-has-overlay" }, { kind: "directive", type: BsButtonTypeDirective, selector: "button[color],input[type=\"button\"][color],input[type=\"submit\"][color],a[color]", inputs: ["color"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsDatepickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-datepicker', standalone: true, imports: [DatePipe, BsCalendarComponent, BsDropdownModule, BsButtonTypeDirective, BsHasOverlayComponent], template: "<!-- <bs-dropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\"></bs-dropdown> -->\n<div bsDropdown [hasBackdrop]=\"true\" [closeOnClickOutside]=\"true\">\n    <button bsDropdownToggle [color]=\"colors.primary\">{{ selectedDate | date }}</button>\n    <bs-has-overlay></bs-has-overlay>\n    <div *bsDropdownMenu>\n        <bs-calendar [(selectedDate)]=\"selectedDate\" [(currentMonth)]=\"currentMonth\" [disableDateFn]=\"disableDateFn\"></bs-calendar>\n    </div>\n</div>" }]
        }], propDecorators: { selectedDateChange: [{
                type: Output
            }], selectedDate: [{
                type: Input
            }], currentMonthChange: [{
                type: Output
            }], currentMonth: [{
                type: Input
            }], disableDateFn: [{
                type: Input
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { BsDatepickerComponent };
//# sourceMappingURL=mintplayer-ng-bootstrap-datepicker.mjs.map
