import * as i0 from '@angular/core';
import { Directive, Input } from '@angular/core';

class BsLetDirective {
    // eslint-disable-next-line no-unused-vars
    constructor(viewContainer, templateRef) {
        this.viewContainer = viewContainer;
        this.templateRef = templateRef;
        this.context = { bsLet: null, $implicit: null };
        this.hasView = false;
    }
    set bsLet(value) {
        this.context.$implicit = this.context.bsLet = value;
        if (!this.hasView) {
            this.hasView = true;
            this.viewContainer.createEmbeddedView(this.templateRef, this.context);
        }
    }
    /**
     * Asserts the correct type of the context for the template that `NgLet` will render.
     *
     * The presence of this method is a signal to the Ivy template type-check compiler that the
     * `NgLet` structural directive renders its template with a specific context type.
     */
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsLetDirective, deps: [{ token: i0.ViewContainerRef }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "17.3.1", type: BsLetDirective, isStandalone: true, selector: "[bsLet]", inputs: { bsLet: "bsLet" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsLetDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bsLet]',
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i0.ViewContainerRef }, { type: i0.TemplateRef }], propDecorators: { bsLet: [{
                type: Input
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { BsLetDirective };
//# sourceMappingURL=mintplayer-ng-bootstrap-let.mjs.map
