import * as i0 from '@angular/core';
import { SecurityContext, Pipe } from '@angular/core';
import * as i1 from '@angular/platform-browser';

class BsOrdinalNumberPipe {
    constructor(domSanitizer) {
        this.domSanitizer = domSanitizer;
    }
    transform(value, ...args) {
        const sanitizeRgx = new RegExp(`[^A-Za-z]`, 'gm');
        const countWords = args.map(w => w.replace(sanitizeRgx, '')).join('|');
        const rgx = new RegExp(`\\b(?<num>[0-9]+)(?<tel>${countWords})\\b`, 'gm');
        const safeValue = this.domSanitizer.sanitize(SecurityContext.HTML, value);
        if (!safeValue)
            return '';
        const result = safeValue.replace(rgx, "$<num><sup>$<tel></sup>");
        const safeResult = this.domSanitizer.bypassSecurityTrustHtml(result);
        return safeResult;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsOrdinalNumberPipe, deps: [{ token: i1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "17.3.1", ngImport: i0, type: BsOrdinalNumberPipe, isStandalone: true, name: "ordinalNumber" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsOrdinalNumberPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ordinalNumber',
                    pure: true,
                    standalone: true
                }]
        }], ctorParameters: () => [{ type: i1.DomSanitizer }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsOrdinalNumberPipe };
//# sourceMappingURL=mintplayer-ng-bootstrap-ordinal-number.mjs.map
