import { AsyncPipe } from '@angular/common';
import * as i0 from '@angular/core';
import { EventEmitter, Component, Output, Input, HostListener } from '@angular/core';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { BehaviorSubject, distinctUntilChanged } from 'rxjs';

class BsPlaylistTogglerComponent {
    constructor() {
        //#region State
        this.state$ = new BehaviorSubject(false);
        this.stateChange = new EventEmitter();
        //#endregion
        this.toggleOnClick = true;
        this.state$.pipe(distinctUntilChanged(), takeUntilDestroyed())
            .subscribe(state => this.stateChange.emit(state));
    }
    get state() {
        return this.state$.value;
    }
    set state(value) {
        this.state$.next(value);
    }
    toggleState(ev) {
        if (this.toggleOnClick) {
            this.state$.next(!this.state);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsPlaylistTogglerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.1", type: BsPlaylistTogglerComponent, isStandalone: true, selector: "bs-playlist-toggler", inputs: { state: "state", toggleOnClick: "toggleOnClick" }, outputs: { stateChange: "stateChange" }, host: { listeners: { "click": "toggleState($event)" } }, ngImport: i0, template: "<div class=\"playlist-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [".playlist-toggler{width:3.5rem;padding:.75rem}.playlist-toggler>div{width:25px;height:2px;background:#bbb;margin:6px 0;transition:.4s}.playlist-toggler.open>div:nth-of-type(1){-webkit-transform:rotate(-45deg) translate(-7px,5px);transform:rotate(-45deg) translate(-7px,5px)}.playlist-toggler.open>div:nth-of-type(2){-webkit-transform:rotate(90deg) translate(0px,14px);transform:rotate(90deg) translateY(14px);opacity:0}.playlist-toggler.open>div:nth-of-type(3){-webkit-transform:rotate(45deg) translate(-6px,-4px);transform:rotate(45deg) translate(-6px,-4px)}.playlist-toggler:not(.open)>div:nth-of-type(1){-webkit-transform:rotate(-30deg) translate(-10px,11px);transform:rotate(-30deg) translate(-10px,11px)}.playlist-toggler:not(.open)>div:nth-of-type(2){-webkit-transform:rotate(90deg) translate(0px,14px);transform:rotate(90deg) translateY(14px);opacity:1}.playlist-toggler:not(.open)>div:nth-of-type(3){-webkit-transform:rotate(30deg) translate(-10px,-11px);transform:rotate(30deg) translate(-10px,-11px)}\n"], dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsPlaylistTogglerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-playlist-toggler', standalone: true, imports: [AsyncPipe], template: "<div class=\"playlist-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [".playlist-toggler{width:3.5rem;padding:.75rem}.playlist-toggler>div{width:25px;height:2px;background:#bbb;margin:6px 0;transition:.4s}.playlist-toggler.open>div:nth-of-type(1){-webkit-transform:rotate(-45deg) translate(-7px,5px);transform:rotate(-45deg) translate(-7px,5px)}.playlist-toggler.open>div:nth-of-type(2){-webkit-transform:rotate(90deg) translate(0px,14px);transform:rotate(90deg) translateY(14px);opacity:0}.playlist-toggler.open>div:nth-of-type(3){-webkit-transform:rotate(45deg) translate(-6px,-4px);transform:rotate(45deg) translate(-6px,-4px)}.playlist-toggler:not(.open)>div:nth-of-type(1){-webkit-transform:rotate(-30deg) translate(-10px,11px);transform:rotate(-30deg) translate(-10px,11px)}.playlist-toggler:not(.open)>div:nth-of-type(2){-webkit-transform:rotate(90deg) translate(0px,14px);transform:rotate(90deg) translateY(14px);opacity:1}.playlist-toggler:not(.open)>div:nth-of-type(3){-webkit-transform:rotate(30deg) translate(-10px,-11px);transform:rotate(30deg) translate(-10px,-11px)}\n"] }]
        }], ctorParameters: () => [], propDecorators: { stateChange: [{
                type: Output
            }], state: [{
                type: Input
            }], toggleOnClick: [{
                type: Input
            }], toggleState: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { BsPlaylistTogglerComponent };
//# sourceMappingURL=mintplayer-ng-bootstrap-playlist-toggler.mjs.map
