import * as i0 from '@angular/core';
import { Pipe } from '@angular/core';

class BsSlugifyPipe {
    transform(value) {
        return value.toString().toLowerCase()
            .replace(/\s+/g, '-') // Replace spaces with -
            .normalize("NFD").replace(/[\u0300-\u036f]/g, "") // Remove diacritics
            .replace(/[^\w\-]+/g, '') // Remove all non-word chars
            .replace(/\-\-+/g, '-') // Replace multiple - with single -
            .replace(/^-+/, '') // Trim - from start of text
            .replace(/-+$/, ''); // Trim - from end of text
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsSlugifyPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "17.3.1", ngImport: i0, type: BsSlugifyPipe, isStandalone: true, name: "bsSlugify" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.1", ngImport: i0, type: BsSlugifyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsSlugify',
                    pure: true,
                    standalone: true
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsSlugifyPipe };
//# sourceMappingURL=mintplayer-ng-bootstrap-slugify.mjs.map
